package BaglantiliListe;

public class BagliListe {
    private Dugum bas;
    private Dugum son;
    private int elemanSayisi;

    public BagliListe() {
        bas = son = null;
        elemanSayisi = 0;
    }

    public void add(int poz, int e){
        if (poz < 0 || poz > elemanSayisi) {
            System.out.println("HATA: "+poz +". pozisyona "+e+" "
                    + "değeri ekleme işleminiz tamamlanamadı. "
                    + "Girilen pozisyon değeri geçersiz."
                    + "(Girilebilecek maksimum pozisyon değeri : "+elemanSayisi+ ")\n\n");
            return;
        }

        Dugum temp = new Dugum();
        temp.veri = e;
        temp.sonraki = null;

        // başa ekleme
        if (poz == 0) {
            temp.sonraki = bas;
            bas = temp;
            if (son == null) {
                son = temp;
            }

            // sona ekleme
        } else if (poz == elemanSayisi) {
            if (son != null) {
                son.sonraki = temp;
                son = temp;
            } else {
                bas = temp;
                //son = temp;
            }
            // ortaya ekleme
        } else {
            Dugum p = bas;
            for (int i = 1; i < poz; i++) {
                p = p.sonraki;
            }

            temp.sonraki = p.sonraki;
            p.sonraki = temp;
        }

        elemanSayisi++;
    }

    public int indexOf(int e){
        Dugum p = bas;
        int i=0;
        for( ; p != null ; p = p.sonraki, i++){
            if(e == p.veri)
                return i;
        }

        return -1;
    }

    public int get(int poz){
        Dugum p = bas;

        for(int i=0 ; i<elemanSayisi ; i++){
            if(i == poz)
                return p.veri;
            p = p.sonraki;
        }
        return -1;
    }

    public int size(){
        return elemanSayisi;
    }

    public int first(){
        return bas.veri;
    }

    public int last(){
        return son.veri;
    }

    public boolean isEmpty(){
        if(bas == null)
            return true;
        else
            return false;
    }

    public void print() {
        Dugum p = bas;

        for (; p != null; p = p.sonraki) {
            System.out.print(p.veri + " ");
        }

        System.out.println("");
    }

    public void remove(int poz){
        if(isEmpty()){
            System.out.println("HATA: Liste boş");
            return;
        } else if(poz >= elemanSayisi){
            System.out.println("HATA: Geçersiz pozisyon "+poz+"\n"
                    + "Pozisyon değeri 0 ile "+(elemanSayisi-1)+" arasında olmalı");
            return;
        }

        // bastan silme
        if(poz == 0){
            bas = bas.sonraki;
            elemanSayisi--;
            return;
        }

        // ortadan ve baştan silme
        Dugum p = bas.sonraki;
        Dugum q = bas;

        for(int i=1; i<elemanSayisi ; i++){
            if(i == poz){
                q.sonraki = p.sonraki;
                elemanSayisi--;
                return;
            }
            p = p.sonraki;
            q = q.sonraki;
        }
    }
}
